package pp;

import java.io.IOException;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import pp.model.Player;
import pp.model.Vector2D;
import pp.network.*;
import pp.ui.*;

public class PlatformPuzzler extends MIDlet implements CommandListener, MessageListener{

	//UI Elements:
    private Form main;
    private TextField ipText;
    private Display display;
    //private TextField passwordField; // not used
    
    //Commands
    private Command exit; 
    private Command connect;
    
    //Network variables::
    private ClientConnector connection;
    private MessageHandler mHandler;
	
    //Constants::
    private final int SERVER_PORT=5338;
    
    //Constructor::
	public PlatformPuzzler(){
		main = new Form("Platform Puzzler");
        
		//Initialize network variables::
		mHandler=new MessageHandler(this);
		
		//Welcome message::
        main.append(new StringItem(null, "Welcome to Platform Puzzler"));
        
        //Add ip::
        ipText =new TextField("Server adress:","",50,TextField.URL);
        main.append(ipText);
        
        //Initialize UI::
        connect=new Command("Start",Command.SCREEN,0);
        exit=new Command("Exit",Command.EXIT,0);
        main.addCommand(connect);
        main.addCommand(exit);
        main.setCommandListener(this);
        display=Display.getDisplay(this);
	} 
 
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		// TODO Auto-generated method stub

	}

	protected void pauseApp() {  
		// TODO Auto-generated method stub

	} 

	//Starts the game and sets up the display::
	protected void startApp() throws MIDletStateChangeException {
		display.setCurrent(main);
	}

	//Checks the command actions::
	public void commandAction(Command command, Displayable arg1) {
		//Quit the game::
		if(command==exit)notifyDestroyed();
		
		//Connect to the game::
		if(command==connect){
			try {
				final String serverAddress=ipText.getString();
				new Thread(
                        new Runnable(){
                            public void run(){
                                try{
                                    connection=new ClientConnector(serverAddress,SERVER_PORT,mHandler);
                                    connection.sendMessage(mHandler.createJoinRequest());
                                }catch(Exception e){}
                            }
                        }
                    ).start();
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	//NETWORK MESSAGE HANDLING CODE::
	public void notifyClubRequest(int id,boolean right) {
		// TODO Auto-generated method stub		
	}
	public void notifyCreatePlayer(int id, Vector2D pos) {
		// TODO Auto-generated method stub		
	}
	public void notifyDisconnectRequest() {
		// TODO Auto-generated method stub		
	}
	public void notifyExitReached() {
		// TODO Auto-generated method stub		
	}
	public void notifyInitClubbing(boolean right) {
		// TODO Auto-generated method stub		
	}
	/*
	 * The server notifies the client that it can join the server, and the client then
	 * should create a new GameWindow and a player
	 */
	public void notifyJoinAck(int id) {	
		GameWindow gw;
		try {
			gw = new GameWindow(this,connection,new Player(new Vector2D(0,0),id));
			display.setCurrent(gw);
		} catch (IOException e) {
			e.printStackTrace();
		}			
	}
	public void notifyJoinRequest() {
		// TODO Auto-generated method stub		
	}
	public void notifyLoadLevel(String lvlName,Vector2D startPos) {	
		// TODO Auto-generated method stub		
	}
	public void notifyPlayerDisconnect(int id) {
		// TODO Auto-generated method stub		
	}
	public void notifyPosition(Vector2D pos) {
		// TODO Auto-generated method stub		
	}
	public void notifyPositionChange(int id, Vector2D pos) {
		// TODO Auto-generated method stub		
	}
	public void notifyPositionRequest() {
		// TODO Auto-generated method stub	
	}
	public void notifyTriggerEvent(int eventID) {
		// TODO Auto-generated method stub		
	}
	public void notifyTriggerEventRequest(int eventID) {
		// TODO Auto-generated method stub		
	}
}