package pp.model;

import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

public class Club extends Sprite{
	
	//Variables::
	private Player owner;
	private Vector2D pos;
	private int clubCounter=0;
	private boolean clubbing=false;
	
	//Constants::
	private final int MAX_COUNTER=12;
	
	//Constants::
	public static final String CLUB_SPRITE_NAME="/pp/images/club.png";
	
	//Constructor::
	public Club(Player o,Image img){
		super(img);
		owner=o;
		
		//Initial placement of image
		pos=new Vector2D(owner.getVPos().x+LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT/2,owner.getVPos().y+LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT/2);
		defineReferencePixel(LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT/2, LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT);//Define the reference pixel as approximately the bottom middle of the image
		setRefPixelPosition(pos.x,pos.y);//sets the reference pixel as used in transformations
	}
	
	//Updates the position of the club::
	public void updateClubPosition(){
		setRefPixelPosition(pos.x,pos.y);
		
		//Updates the clubbing transformation::
		if(clubbing && clubCounter<MAX_COUNTER){
			if(owner.isRight()){
				setTransform(TRANS_MIRROR_ROT90);
			}else{
				setTransform(TRANS_MIRROR_ROT270);
			}
			if( !((++clubCounter) < MAX_COUNTER) ){
				clubCounter=0;
				clubbing=false;
				setTransform(TRANS_NONE);
			}
		}
		
	}
	
	//Updates the position of the club according to the owners position::
	public void updateOwnerClub(){
		pos.setVectorValues(owner.getVPos().x+LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT/2,owner.getVPos().y+LevelGenerator.LEVEL_BLOCK_WIDTHxHEIGHT/2);
	}
	
	//Adds the vector values of vector 'v' to the position vector::
	public void addVector(Vector2D v){
		pos.addVector(v);
	}
	
	//Adds values to the position vector::
	public void addVectorValues(int x,int y){
		pos.addVectorValues(x, y);
	}
	
	//Starts the clubbing::
	public void startClubbing(){
		if(!clubbing){
			clubbing=true;
			clubCounter=0;
		}		
	}
	
	//Getters and setters::
	public boolean isClubbing() {
		return clubbing;
	}
}
