package pp.model;

import java.util.Vector;
import pp.model.event.PPTrigger;

public class Level {

	//Constants::
	public final static char LEVEL_CONST_START_BLOCK='s';
	public final static char LEVEL_CONST_END_BLOCK='e';
	public final static char LEVEL_CONST_SPACE='\u0020';
	public final static char LEVEL_CONST_LINE_BREAK='\n';
	public final static char LEVEL_CONST_INVISIBLE_SPACE_THINGIE='\r';
	public final static String LEVEL_END="none";
	
	//Variables::
	private Vector lvlObjects;
	private Vector movableObjects;
	private Vector triggerObjects;
	private Vector exitObjects;
	private PPTrigger trigger;
	
	//Constructor::
	public Level(PPTrigger trig){
		lvlObjects=new Vector();
		movableObjects=new Vector();
		triggerObjects=new Vector();
		exitObjects=new Vector();
		trigger=trig;
	}
	
	//Returns the PPObject at position 'i'::
	public PPObject getLvlObject(int i){
		if(i>-1 && i<lvlObjects.size()){
			return (PPObject)lvlObjects.elementAt(i);
		}else{
			return null;
		}
	}
	//Adds a PPObject to the object list::
	public void addLvlObject(PPObject obj){
		lvlObjects.addElement(obj);
	}
	//Returns length of object vector::
	public int getLvlObjectSize(){
		return lvlObjects.size();
	}
	//Returns the PPObject at position 'i'::
	public PPObject getMovableObject(int i){
		if(i>-1 && i<movableObjects.size()){
			return (PPObject)movableObjects.elementAt(i);
		}else{
			return null;
		}
	}
	//Adds a PPObject to the object list::
	public void addMovableObject(PPObject obj){
		movableObjects.addElement(obj);
	}
	//Returns length of object vector::
	public int getMovableObjectSize(){
		return movableObjects.size();
	}
	//Returns the PPObject at position 'i' int the trigger list::
	public PPObject getTriggerObject(int i){
		if(i>-1 && i<triggerObjects.size()){
			return (PPObject)triggerObjects.elementAt(i);
		}else{
			return null;
		}
	}
	//Adds a PPObject to the trigger object list::
	public void addTriggerObject(PPObject obj){
		triggerObjects.addElement(obj);
	}
	//Returns length of trigger object vector::
	public int getTriggerObjectSize(){
		return triggerObjects.size();
	}
	//Returns the PPObject at position 'i' int the exit list::
	public PPObject getExitObject(int i){
		if(i>-1 && i<exitObjects.size()){
			return (ExitPPObject)exitObjects.elementAt(i);
		}else{
			return null;
		}
	}
	//Adds a PPObject to the exit object list::
	public void addExitObject(ExitPPObject obj){
		exitObjects.addElement(obj);
	}
	//Returns length of exit object vector::
	public int getExitObjectSize(){
		return exitObjects.size();
	}
}