package pp.ui;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;
import javax.microedition.midlet.MIDlet;

public class EndWindow extends Form implements CommandListener{

	//UI elements::
	private Command exitCommand;
	private MIDlet parent;
	private StringItem endText;	
	
	//Constants::
	private final String END_TEXT="You have now finished the demo. Please press 'Exit' to end the game.";
	
	//Constructor::
	public EndWindow(MIDlet p){
		super("Platform Puzzler");
		parent=p;
		
		//Add end text::
		endText=new StringItem(null,END_TEXT);
		append(endText);
		
		//Initialize commands::
		exitCommand=new Command("Exit",Command.EXIT,0);
		addCommand(exitCommand);
		setCommandListener(this);
		Display.getDisplay(parent).setCurrent(this);
	}
	
	/**
	 * Handles commands
	 */
	public void commandAction(Command arg0, Displayable arg1) {
		//If the command was the exit command, notify the parent midlet and end the game::
		if(arg0==exitCommand)parent.notifyDestroyed();		
	}
}
