/*
 * TestClient.java
 */

package pps.server;

import java.io.*;
import java.net.*;
import java.util.*;

public class TestClient implements Runnable{
    
     private Socket socket = null;
     private PrintWriter out = null;
     private BufferedReader in = null;
     
     private Sender sender;
     private Receiver receiver;
    
     public TestClient(){
         try {
            socket = new Socket("192.168.2.2",1337);
            out = new PrintWriter(socket.getOutputStream(), true);
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            sender=new Sender();
            receiver=new Receiver();
            new Thread(sender).start();
            new Thread(receiver).start();
        } catch (Exception e){
            e.printStackTrace();
        }
     }
     
     public void sendMessage(String message){
         sender.sendMessage(message);
     }
     
     public void run(){
        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
        String fromUser="";

        while (true) {  
            try{
                fromUser = stdIn.readLine();
            }catch(Exception e){
                e.printStackTrace();
            }
            if (fromUser != null) {
                System.out.println("Client: " + fromUser);
                out.println(fromUser);
	    }
        }
     }
     
     public void close(){
         try{
             out.close();
             in.close();
             socket.close();
         }catch(Exception e){
             e.printStackTrace();
         }
     }
     
    public static void main(String[] args) throws IOException {
        new Thread(new TestClient()).start();
    }
    
    private class Receiver implements Runnable{
        
        private boolean running=true;
        
        public void run() {
            while(socket==null){/*wait*/}
            while(running){
                try{
                    String message=in.readLine();//receive message;
                    System.out.println("Message received: "+message);
                }catch(Exception e){
                    e.printStackTrace();
                }
            }            
        }
    
    }
    
    private class Sender implements Runnable{
        private LinkedList<String> messageQueue;
        boolean running=true;
        
        public Sender(){
            messageQueue=new LinkedList<String>();
        }
        
        public void sendMessage(String message){
            messageQueue.add(message);
            synchronized(this){
                this.notify();
            }
        }                
        public void run() {
            while(running){
                synchronized(this){
                    try{
                        while(!messageQueue.isEmpty()){
                            String m=messageQueue.getFirst();
                            out.println(m);
                            messageQueue.removeFirst();
                            System.out.println("Sent message: "+m);
                            Thread.sleep(5);
                        }
                        this.wait();
                    }catch(Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }
    }    
}
